/****************************************************************************************
*  YAROCK                                                                               *
*  Copyright (c) 2010-2013 Sebastien amardeilh <sebastien.amardeilh+yarock@gmail.com>   *
*                                                                                       *
*  This program is free software; you can redistribute it and/or modify it under        *
*  the terms of the GNU General Public License as published by the Free Software        *
*  Foundation; either version 2 of the License, or (at your option) any later           *
*  version.                                                                             *
*                                                                                       *
*  This program is distributed in the hope that it will be useful, but WITHOUT ANY      *
*  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A      *
*  PARTICULAR PURPOSE. See the GNU General Public License for more details.             *
*                                                                                       *
*  You should have received a copy of the GNU General Public License along with         *
*  this program.  If not, see <http://www.gnu.org/licenses/>.                           *
*****************************************************************************************/


#ifndef _LYRICS_PROVIDER_H_
#define _LYRICS_PROVIDER_H_

#include <QString>

#include "provider_base.h"
#include "ultimatelyricsreader.h"

class UltimateLyricsProvider;
typedef QList<UltimateLyricsProvider*> ProviderList;

namespace LYRICS {

struct Result
{
    QString  m_provider_name;
    QString  m_lyrics;
    QString  m_url;
};

} // end namespace LYRICS

/*
********************************************************************************
*                                                                              *
*    Class LyricsProvider                                                      *
*                                                                              *
********************************************************************************
*/
class LyricsProvider : public QObject, public InfoProvider
{
Q_OBJECT
  public :
    LyricsProvider(QObject* parent=0);
    ~LyricsProvider();

    void init();
    void cancel_searches();
    void fetch_info(int id);

  private:
    bool is_local_lyrics(int id);

  private slots:
    void slot_ultimate_lyrics_parsed();
    void slot_fetch_lyrics(int id);
    void slot_lyrics_fetched(int id,const QString& lyric);

  private:
    UltimateLyricsReader   *m_ultimateLyricsReader;
    ProviderList            m_providers;
    ProviderList            m_current_providers;

  signals:
    void LyricsOK(int id,LYRICS::Result& result);
};

#endif // _LYRICS_PROVIDER_H_
